package com.huiju.welcome.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huiju.welcome.common.base.BaseController;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.model.TaCarRecord;
import com.huiju.welcome.service.ITaCarRecordService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-06-18
 */
@RestController
@RequestMapping("/")
@Api(value = "车辆来访记录", description = "车辆来访记录")
public class TaCarRecordController extends BaseController {

    @Autowired
    private ITaCarRecordService iTaCarRecordService;


    @RequestMapping(value = "/carRecord", method = RequestMethod.GET)
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "query", dataType = "String", name = "plateNumber", value = "车牌"),
            @ApiImplicitParam(paramType = "query", dataType = "Date", name = "recordDate", value = "来访时间"),
            @ApiImplicitParam(paramType = "query", dataType = "String", name = "customerName", value = "客户姓名"),
            @ApiImplicitParam(paramType = "query", dataType = "String", name = "phone", value = "手机号"),
            @ApiImplicitParam(paramType = "query", dataType = "int", name = "pageNum", value = "当前页"),
            @ApiImplicitParam(paramType = "query", dataType = "int", name = "pageSize", value = "每页数量"),
    })
    public ResponseBean list(@RequestParam(value = "plateNumber", required = false) String plateNumber,
                             @RequestParam(value = "recordDate", required = false) @DateTimeFormat(pattern = "yyyy-MM-dd") Date recordDate,
                             @RequestParam(value = "customerName", required = false) String customerName,
                             @RequestParam(value = "phone", required = false) String phone,
                             @RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum,
                             @RequestParam(value = "pageSize", defaultValue = "1") Integer pageSize) {
        ResponseBean responseBean = new ResponseBean();

        IPage<TaCarRecord> page = new Page<>();
        page.setCurrent(pageNum);
        page.setSize(pageSize);

        IPage<TaCarRecord> pageList = iTaCarRecordService.getPageList(page, plateNumber, recordDate, customerName, phone);
        responseBean.addSuccess(pageList);
        return responseBean;
    }

}
